#include "stdafx.h"
#include "npfunctions.h"

NPNetscapeFuncs gBrowserFuncTable = { 0 };

NPError NPN_GetValue( NPP instance, NPNVariable variable, void *ret_value )
{
	if ( gBrowserFuncTable.getvalue != NULL )
		return gBrowserFuncTable.getvalue( instance, variable, ret_value );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_SetValue( NPP instance, NPPVariable variable, void *value )
{
	if ( gBrowserFuncTable.setvalue != NULL )
		return gBrowserFuncTable.setvalue( instance, variable, value );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_GetURLNotify( NPP instance, const char *url, const char *window, void *notifyData )
{
	if ( gBrowserFuncTable.geturlnotify != NULL )
		return gBrowserFuncTable.geturlnotify( instance, url, window, notifyData );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_PostURLNotify( NPP instance, const char *url, const char *window, uint32_t len, const char *buf, NPBool file, void *notifyData )
{
	if ( gBrowserFuncTable.posturlnotify != NULL )
		return gBrowserFuncTable.posturlnotify( instance, url, window, len, buf, file, notifyData );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_GetURL( NPP instance, const char *url, const char *window )
{
	if ( gBrowserFuncTable.geturl != NULL )
		return gBrowserFuncTable.geturl( instance, url, window );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_PostURL( NPP instance, const char *url, const char *window, uint32_t len, const char *buf, NPBool file )
{
	if ( gBrowserFuncTable.posturl != NULL )
		return gBrowserFuncTable.posturl( instance, url, window, len, buf, file );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_RequestRead( NPStream *stream, NPByteRange *rangeList )
{
	if ( gBrowserFuncTable.requestread != NULL )
		return gBrowserFuncTable.requestread( stream, rangeList );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_NewStream( NPP instance, NPMIMEType type, const char *window, NPStream **stream )
{
	if ( gBrowserFuncTable.newstream != NULL )
		return gBrowserFuncTable.newstream( instance, type, window, stream );
	else
		return NPERR_GENERIC_ERROR;
}

int32_t NPN_Write( NPP instance, NPStream *stream, int32_t len, void *buffer )
{
	if ( gBrowserFuncTable.write != NULL )
		return gBrowserFuncTable.write( instance, stream, len, buffer );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_DestroyStream( NPP instance, NPStream *stream, NPReason reason )
{
	if ( gBrowserFuncTable.destroystream != NULL )
		return gBrowserFuncTable.destroystream( instance, stream, reason );
	else
		return NPERR_GENERIC_ERROR;
}

void NPN_Status( NPP instance, const char *message )
{ 
	if ( gBrowserFuncTable.status != NULL )
		gBrowserFuncTable.status( instance, message );
}

const char *NPN_UserAgent( NPP instance )
{
	if ( gBrowserFuncTable.uagent != NULL )
		return gBrowserFuncTable.uagent( instance );
	else
		return NULL;
}

void *NPN_MemAlloc( uint32_t size )
{
	if ( gBrowserFuncTable.memalloc != NULL )
		return gBrowserFuncTable.memalloc( size );
	else
		return NULL;
}

void NPN_MemFree( void *ptr )
{
	if ( gBrowserFuncTable.memfree != NULL )
		gBrowserFuncTable.memfree( ptr );
}

uint32_t NPN_MemFlush( uint32_t size )
{
	if ( gBrowserFuncTable.memflush != NULL )
		return gBrowserFuncTable.memflush( size );
	else
		return 0;
}

void NPN_ReloadPlugins( NPBool reloadPages )
{
	if ( gBrowserFuncTable.reloadplugins != NULL )
		gBrowserFuncTable.reloadplugins( reloadPages );
}

void *NPN_GetJavaEnv()
{
	if ( gBrowserFuncTable.getJavaEnv != NULL )
		return gBrowserFuncTable.getJavaEnv();
	else
		return NULL;
}

void *NPN_GetJavaPeer( NPP instance )
{
	if ( gBrowserFuncTable.getJavaPeer != NULL )
		return gBrowserFuncTable.getJavaPeer( instance );
	else
		return NULL;
}

void NPN_InvalidateRect( NPP instance, NPRect *rect )
{
	if ( gBrowserFuncTable.invalidaterect != NULL )
		gBrowserFuncTable.invalidaterect( instance, rect );
}

void NPN_InvalidateRegion( NPP instance, NPRegion region )
{
	if ( gBrowserFuncTable.invalidateregion != NULL )
		gBrowserFuncTable.invalidateregion( instance, region );
}

void NPN_ForceRedraw( NPP instance )
{
	if ( gBrowserFuncTable.forceredraw != NULL )
		gBrowserFuncTable.forceredraw( instance );
}

NPIdentifier NPN_GetStringIdentifier( const NPUTF8 *name )
{
	if ( gBrowserFuncTable.getstringidentifier != NULL )
		return gBrowserFuncTable.getstringidentifier( name );
	else
		return NULL;
}

void NPN_GetStringIdentifiers( const NPUTF8 **names, int32_t nameCount, NPIdentifier *identifiers )
{
	if ( gBrowserFuncTable.getstringidentifiers != NULL )
		gBrowserFuncTable.getstringidentifiers( names, nameCount, identifiers );
}

NPIdentifier NPN_GetIntIdentifier( int32_t intid )
{
	if ( gBrowserFuncTable.getintidentifier != NULL )
		return gBrowserFuncTable.getintidentifier( intid );
	else
		return NULL;
}

bool NPN_IdentifierIsString( NPIdentifier identifier )
{
	if ( gBrowserFuncTable.identifierisstring != NULL )
		return gBrowserFuncTable.identifierisstring( identifier );
	else
		return false;
}

NPUTF8 *NPN_UTF8FromIdentifier( NPIdentifier identifier )
{
	if ( gBrowserFuncTable.utf8fromidentifier != NULL )
		return gBrowserFuncTable.utf8fromidentifier( identifier );
	else
		return NULL;
}

int32_t NPN_IntFromIdentifier( NPIdentifier identifier )
{
    return 0;
}

NPObject *NPN_CreateObject( NPP instance, NPClass *aClass )
{
	if ( gBrowserFuncTable.createobject != NULL )
		return gBrowserFuncTable.createobject( instance, aClass );
	else
		return NULL;
}

NPObject *NPN_RetainObject( NPObject *obj )
{
	if ( gBrowserFuncTable.retainobject != NULL )
		return gBrowserFuncTable.retainobject( obj );
	else
		return NULL;
}

void NPN_ReleaseObject( NPObject *obj )
{
	if ( gBrowserFuncTable.releaseobject != NULL )
		gBrowserFuncTable.releaseobject( obj );
}

bool NPN_Invoke( NPP instance, NPObject *obj, NPIdentifier methodName, const NPVariant *args, uint32_t argCount, NPVariant *result )
{
	if ( gBrowserFuncTable.invoke != NULL )
		return gBrowserFuncTable.invoke( instance, obj, methodName, args, argCount, result );
	else
		return false;
}

bool NPN_InvokeDefault( NPP instance, NPObject *obj, const NPVariant *args, uint32_t argCount, NPVariant *result )
{
	if ( gBrowserFuncTable.invokeDefault != NULL )
		return gBrowserFuncTable.invokeDefault( instance, obj, args, argCount, result );
	else
		return false;
}

bool NPN_Evaluate( NPP instance, NPObject *obj, NPString *script, NPVariant *result )
{
	if ( gBrowserFuncTable.evaluate != NULL )
		return gBrowserFuncTable.evaluate( instance, obj, script, result );
	else
		return false;
}

bool NPN_GetProperty( NPP instance, NPObject *obj, NPIdentifier propertyName, NPVariant *result )
{
	if ( gBrowserFuncTable.getproperty != NULL )
		return gBrowserFuncTable.getproperty( instance, obj, propertyName, result );
	else
		return false;
}

bool NPN_SetProperty( NPP instance, NPObject *obj, NPIdentifier propertyName, const NPVariant *value )
{
	if ( gBrowserFuncTable.setproperty != NULL )
		return gBrowserFuncTable.setproperty( instance, obj, propertyName, value );
	else
		return false;
}

bool NPN_RemoveProperty( NPP instance, NPObject *obj, NPIdentifier propertyName )
{
	if ( gBrowserFuncTable.removeproperty != NULL )
		return gBrowserFuncTable.removeproperty( instance, obj, propertyName );
	else
		return false;
}

bool NPN_HasProperty( NPP instance, NPObject *obj, NPIdentifier propertyName )
{
	if ( gBrowserFuncTable.hasproperty != NULL )
		return gBrowserFuncTable.hasproperty( instance, obj, propertyName );
	else
		return false;
}

bool NPN_HasMethod( NPP instance, NPObject *obj, NPIdentifier propertyName )
{
	if ( gBrowserFuncTable.hasmethod != NULL )
		return gBrowserFuncTable.hasmethod( instance, obj, propertyName );
	else
		return false;
}

void NPN_ReleaseVariantValue( NPVariant *variant )
{
	if ( gBrowserFuncTable.releasevariantvalue != NULL )
		gBrowserFuncTable.releasevariantvalue( variant );
}

void NPN_SetException( NPObject *obj, const NPUTF8 *message )
{
	if ( gBrowserFuncTable.setexception != NULL )
		gBrowserFuncTable.setexception( obj, message );
}

#if USE_BOOL_FOR_POPUP_STACK
	bool NPN_PushPopupsEnabledState( NPP instance, NPBool enabled )
	{
		if ( gBrowserFuncTable.pushpopupsenabledstate != NULL )
			return gBrowserFuncTable.pushpopupsenabledstate( instance, enabled );
		else
			return false;
	}

	bool NPN_PopPopupsEnabledState( NPP instance )
	{
		if ( gBrowserFuncTable.poppopupsenabledstate != NULL )
			return gBrowserFuncTable.poppopupsenabledstate( instance );
		else
			return false;
	}
#else
	void NPN_PushPopupsEnabledState( NPP instance, NPBool enabled )
	{
		if ( gBrowserFuncTable.pushpopupsenabledstate != NULL )
			gBrowserFuncTable.pushpopupsenabledstate( instance, enabled );
	}

	void NPN_PopPopupsEnabledState( NPP instance )
	{
		if ( gBrowserFuncTable.poppopupsenabledstate != NULL )
			gBrowserFuncTable.poppopupsenabledstate( instance );
	}
#endif

bool NPN_Enumerate( NPP instance, NPObject *obj, NPIdentifier **identifier, uint32_t *count )
{
	if ( gBrowserFuncTable.enumerate != NULL )
		return gBrowserFuncTable.enumerate( instance, obj, identifier, count );
	else
		return false;
}

void NPN_PluginThreadAsyncCall( NPP instance, void ( *func )( void  *), void *userData )
{
	if ( gBrowserFuncTable.pluginthreadasynccall != NULL )
		gBrowserFuncTable.pluginthreadasynccall( instance, func, userData );
}

bool NPN_Construct( NPP instance, NPObject *obj, const NPVariant *args, uint32_t argCount, NPVariant *result )
{
	if ( gBrowserFuncTable.construct != NULL )
		return gBrowserFuncTable.construct( instance, obj, args, argCount, result );
	else
		return false;
}

NPError NPN_GetValueForURL( NPP instance, NPNURLVariable variable, const char *url, char **value, uint32_t *len )
{
	if ( gBrowserFuncTable.getvalueforurl != NULL )
		return gBrowserFuncTable.getvalueforurl( instance, variable, url, value, len );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_SetValueForURL( NPP instance, NPNURLVariable variable, const char *url, const char *value, uint32_t len )
{
	if ( gBrowserFuncTable.setvalueforurl != NULL )
		return gBrowserFuncTable.setvalueforurl( instance, variable, url, value, len );
	else
		return NPERR_GENERIC_ERROR;
}

NPError NPN_GetAuthenticationInfo( NPP instance, const char *protocol, const char *host, int32_t port, const char *scheme, const char *realm, char **username, uint32_t *ulen, char **password, uint32_t *plen )
{
	if ( gBrowserFuncTable.getauthenticationinfo != NULL )
		return gBrowserFuncTable.getauthenticationinfo( instance, protocol, host, port, scheme, realm, username, ulen, password, plen );
	else
		return NPERR_GENERIC_ERROR;
}

